function BspDPQ

% http://geometrie.hs-nb.de/MATLAB-Programme/BspDPQ.m   Bearbeitungsstand: 11.10.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

syms x0 y0 a b alph t real
global ax 
close('all')
ax=[inf -inf inf -inf];
P=[x0 + a*cos(alph)*cos(t) - b*sin(alph)*sin(t)
   y0 + a*sin(alph)*cos(t) + b*cos(alph)*sin(t)];
deg=sym(pi)/180;
M1=[2 1];
M2=[10 6];
P1=subs(P,{a b alph x0 y0},{1.5 1.2 70*deg M1(1) M1(2)})
P2=subs(P,{a b alph x0 y0},{2.0 1.0 110*deg M2(1) M2(2)})
P1x=inline(char(P1(1)),'t')
P1y=inline(char(P1(2)),'t')
P2x=inline(char(P2(1)),'t')
P2y=inline(char(P2(2)),'t')
tRg=[0:360]*double(deg);
drawPolygon(@plot,[P1x(tRg);P1y(tRg)],'k')
hold('on')
drawPolygon(@plot,[P2x(tRg);P2y(tRg)],'k')
dist=inline('norm([P1x(u(1));P1y(u(1))]-[P2x(u(2));P2y(u(2))])','u','P1x','P1y','P2x','P2y')
u0=[0 0];
u=fminsearch(dist,u0,[],P1x,P1y,P2x,P2y)
drawPolygon(@plot,[P1x(u(1)) P2x(u(2));P1y(u(1)) P2y(u(2))],'--.k','MarkerSize',30)
axis('equal')
axis(ax)
xTck=get(gca,'xTick');
for k=1:length(xTck)
  Schrift([xTck(k);min(ylim)],sprintf('%.0f ',xTck(k)),'Rotation',90,'HorizontalAlignment','right','VerticalAlignment','middle')
end
yTck=get(gca,'yTick');
for k=1:length(yTck)
  Schrift([min(xlim);yTck(k)],sprintf('%.0f ',yTck(k)),'HorizontalAlignment','right','VerticalAlignment','middle')
end
[X,Y]=meshgrid(unique([xlim xTck]),unique([ylim yTck]));
plot(X,Y,X',Y','color',0.5*[1 1 1])
set(gca,'xticklabel',[])
set(gca,'yticklabel',[])
hold('off')
print('-depsc','BspDPQ')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',30,varargin{:});
