function DreieckKongruenz

% http://geometrie.hs-nb.de/MATLAB-Programme/DreieckKongruenz.m   Bearbeitungsstand: 16.1.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf];
deg=pi/180;
phi=[0:360]*deg;

A=[0;0];
c=[50;0];
b=[10;23];

B=A+c; C=A+b; a=C-B;
Polygon([A B C A],'k','linewidth',3.0);
hold('on');

A(2)=A(2)-1.1*b(2); B=A+c; C=A+b;
Polygon([C A B],'k','linewidth',3.0);
Polygon([B C],'k','linewidth',0.25);
Kreisbogen(A+0.1*norm(a)*c/norm(c),A,A+0.1*norm(a)*b/norm(b),0,'k','linewidth',3.0);

A(2)=A(2)-1.1*b(2); B=A+c; C=A+b;
Polygon([C A B],'k','linewidth',3.0);
Polygon([B C],'k','linewidth',0.25);
Kreisbogen(C-0.1*norm(a)*b/norm(b),C,C-0.1*norm(a)*a/norm(a),0,'k','linewidth',3.0);

A(2)=A(2)-1.1*b(2); B=A+c; C=A+b;
Polygon([A B],'k','linewidth',3.0);
Polygon([B C A],'k','linewidth',0.25);
Kreisbogen(A+0.1*norm(a)*c/norm(c),A,A+0.1*norm(a)*b/norm(b),0,'k','linewidth',3.0);
Kreisbogen(B+0.1*norm(a)*a/norm(a),B,B-0.1*norm(a)*c/norm(c),0,'k','linewidth',3.0);

hold('off')
axis('equal')
axis(ax+3*[-1 1 -1 1])
axis('off')
print('-deps','DreieckKongruenz');

function Polygon(P,varargin);
global ax
plot(P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Kreisbogen(A,M,B,offset,varargin)
deg=pi/180;
[t1,r1]=cart2pol(A(1)-M(1),A(2)-M(2));
[t2,r2]=cart2pol(B(1)-M(1),B(2)-M(2));
if abs(r1-r2)>sqrt(eps)
  error('Kreisbogen: A und B liegen nicht auf einem Kreis mit Mittelpunkt M')
end
r=(r1+r2)/2;
t1=t1-offset;
t2=t2+offset;
if t2<t1
  t2=t2+2*pi;
end
t=linspace(t1,t2,round((t2-t1)/deg));
Polygon(repmat(M,size(t))+r*[cos(t);sin(t)],varargin{:});
