function DreieckWSW

% http://geometrie.hs-nb.de/MATLAB-Programme/DreieckWSW.m   Bearbeitungsstand: 18.2.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf];
deg=pi/180;

A=[0;0];
c=[50;0];
b=[10;23];

B=A+c; C=A+b; a=C-B;
Polygon([A B],'k','linewidth',1.5);
hold('on');

Polygon([A C B],'k','linewidth',0.5);
Polygon([C C-0.1*(A-C)],'k','linewidth',0.25);
Polygon([C C-0.1*(B-C)],'k','linewidth',0.25);
Kreisbogen(A+0.1*norm(a)*c/norm(c),A,A+0.1*norm(a)*b/norm(b),0,'k','linewidth',1.5);
Kreisbogen(B+0.1*norm(a)*a/norm(a),B,B-0.1*norm(a)*c/norm(c),0,'k','linewidth',1.5);

A(1)=A(1)+1.1*c(1); B=A+c;
alpha=90*deg+asin(b(2)/norm(a)); 
C1=A+norm(b)*[cos(alpha);sin(alpha)];
beta=0.75*pi-0.5*alpha;
C2=B+norm(b)*[cos(pi-beta);sin(pi-beta)];
Polygon([A B],'k','linewidth',1.5);
Polygon([A C1],'k','linewidth',0.5);
Polygon([B C2],'k','linewidth',0.5);
b=C1-A;
Kreisbogen(A+0.1*norm(a)*c/norm(c),A,A+0.1*norm(a)*b/norm(b),0,'k','linewidth',1.5);
a2=C2-B;
Kreisbogen(B+0.1*norm(a)*a2/norm(a2),B,B-0.1*norm(a)*c/norm(c),0,'k','linewidth',1.5);

hold('off')
axis('equal')
axis(ax)
axis('off')
print('-deps','DreieckWSW');

function Polygon(P,varargin);
global ax
plot(P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Kreisbogen(A,M,B,offset,varargin)
deg=pi/180;
[t1,r1]=cart2pol(A(1)-M(1),A(2)-M(2));
[t2,r2]=cart2pol(B(1)-M(1),B(2)-M(2));
if abs(r1-r2)>sqrt(eps)
  error('Kreisbogen: A und B liegen nicht auf einem Kreis mit Mittelpunkt M')
end
r=(r1+r2)/2;
t1=t1-offset;
t2=t2+offset;
if t2<t1
  t2=t2+2*pi;
end
t=linspace(t1,t2,round((t2-t1)/deg));
Polygon(repmat(M,size(t))+r*[cos(t);sin(t)],varargin{:});
