function Fass

% http://geometrie.hs-nb.de/MATLAB-Programme/Fass.m   Bearbeitungsstand: 3.3.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

deg=pi/180;
syms('t','u','v','real');
clc;
close('all')
a=sqrt(sym(3));
c1=sqrt(1-(u/a)^2)*cos(v);
c2=sqrt(1-(u/a)^2)*sin(v);
xInl=inline('u','u','v');
yInl=inline(vectorize(c1),'u','v');
zInl=inline(vectorize(c2),'u','v');
u=linspace(-1,1,32);
v=[0:1:360]*deg;
[U,V]=meshgrid(u,v);
X=xInl(U,V);
Y=yInl(U,V);
Z=zInl(U,V);
surf(X,Y,Z,V,'EdgeColor','none');
c=0.5+0.375*(sin(pi*[0:size(V,1)-1]/(size(V,1)-1))).^2;
colormap(repmat(c',1,3));
hold('on')
xM=mean(u([1 end]));
for xx=[u(1) xM u(end)]
  plot3(repmat(xx,size(v)),yInl(xx,v),zInl(xx,v),'k','linewidth',2.0)
  fill3(repmat(xx,size(v)),yInl(xx,v),zInl(xx,v),mean(c)*[1 1 1])
end
vRef=v(round(0.5*end));
xi=linspace(-double(a),double(a),100);
plot3(xi,yInl(xi,vRef+0.25*pi),yInl(xi,vRef+0.25*pi),'k','linewidth',0.5)
Schrift([u(1);yInl(u(1),vRef);zInl(u(1),vRef)],{'Grund-' 'flche {\itG}'},...
  'HorizontalAlignment','right','VerticalAlignment','top','erase','none')
Schrift([xM;yInl(xM,vRef);zInl(xM,vRef)],{'"Mittel-^{ }' 'flche" {\itM}_{ }'},...
  'HorizontalAlignment','right','VerticalAlignment','middle','erase','none')
Schrift([u(end);yInl(u(end),vRef);zInl(u(end),vRef)],{'Deck-^{ }' 'flche {\itD}_{ }'},...
  'HorizontalAlignment','right','VerticalAlignment','bottom','erase','none')
plot3(X,Y,Z,'k')
xRg=[min(X(:));max(X(:))]+(max(X(:))-min(X(:)))*[-0.5;0.6];
yRg=[min(Y(:));max(Y(:))]+(max(Y(:))-min(Y(:)))*[-0.0;0.0];
plot3(xRg,[0;0],[0;0],'k','linewidth',2.0)
Spitze([xRg(2);0;0],[1;0;0],0.3,30*deg);
axis('equal')
axis([xRg' yRg' 0.15*min(Z(:)) 0.00*max(Z(:))])
axis('off')
view(90,-60)
print('-deps','Fass','-opengl')

function Schrift(P,txt,varargin)
text(P(1),P(2),P(3),txt,'FontName','TimesNewRoman','FontSize',18,varargin{:});

function Spitze(P,v,L,phi);
deg=pi/180;
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*deg;
end
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
Q=P-v;
t=[0:6:360]*deg;
for k=1:size(P,2)
  N=tan(phi/2)*null(v(:,k)');
  for w=2:length(t)
    plot3(...
      [P(1,k) Q(1,k)+cos(t(w))*L(:,k)*N(1,1)+sin(t(w))*L(:,k)*N(1,2) Q(1,k)+cos(t(w-1))*L(:,k)*N(1,1)+sin(t(w-1))*L(:,k)*N(1,2) P(1,k)],...
      [P(2,k) Q(2,k)+cos(t(w))*L(:,k)*N(2,1)+sin(t(w))*L(:,k)*N(2,2) Q(2,k)+cos(t(w-1))*L(:,k)*N(2,1)+sin(t(w-1))*L(:,k)*N(2,2) P(2,k)],...
      [P(3,k) Q(3,k)+cos(t(w))*L(:,k)*N(3,1)+sin(t(w))*L(:,k)*N(3,2) Q(3,k)+cos(t(w-1))*L(:,k)*N(3,1)+sin(t(w-1))*L(:,k)*N(3,2) P(3,k)],...
      'k');
  end
end
