function HalbkreisSchwerpunkt

% http://geometrie.hs-nb.de/MATLAB-Programme/HalbkreisSchwerpunkt.m   Bearbeitungsstand: 6.3.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

close('all');
deg=pi/180;
ti=[0:180]*deg;
fill(cos(ti),sin(ti),0.875*[1 1 1]);
hold('on');
plot([0;0],[0;4/(3*pi)],'k')
Spitze([0;4/(3*pi)],[0;1],0.1,30*deg);
Spitze([0;0],[0;-1],0.1,30*deg);
Schrift([0;4/(3*pi)],'{\itS}','HorizontalAlignment','center','VerticalAlignment','bottom','erase','none');
Schrift([0;1.8/(3*pi)],'{_{ }\ita}','HorizontalAlignment','left','VerticalAlignment','middle','erase','none');
hold('off');
axis('equal')
axis([-1 1 0 1]+[-0.01 0.01 -0.01 0.01])
axis('off')
print('-deps','HalbkreisSchwerpunkt');

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',40,varargin{:});

function Spitze(P,v,L,phi);
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*pi/180;
end
ta=tan(phi/2);
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
n=[-v(2,:);v(1,:)];
Q=P-v+ta*n;
R=P-v-ta*n;
for k=1:size(P,2);
  fill([P(1,k) Q(1,k) R(1,k)],[P(2,k) Q(2,k) R(2,k)],'k')
end
