function Heron

% http://geometrie.hs-nb.de/MATLAB-Programme/Heron.m   Bearbeitungsstand: 15.2.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf];
a=[11;0];
b=[-3;7];
n=[-a(2);a(1)]/norm(a);
h=n*n'*b;
A=[0;0];
drawPolygon(@plot,[A A+a A+a+b A],'k','linewidth',1.5)
hold('on')
drawPolygon(@plot,[A+a+b A+a+b-h],'k','linewidth',0.25)
hold('off')
Schrift(A+a/2,'\itc=q+p','HorizontalAlignment','center','VerticalAlignment','top');
Schrift(A+a+b/2,'\ita','HorizontalAlignment','center','VerticalAlignment','bottom','rotation',Rot([0;0],b));
Schrift(A+(a+b)/2,'\itb','HorizontalAlignment','center','VerticalAlignment','bottom','rotation',Rot([0;0],a+b));
Schrift(A+a+b-h/2,'\ith','HorizontalAlignment','right','VerticalAlignment','middle');
Schrift(A+(a+b-h)/2,'\itq','HorizontalAlignment','center','VerticalAlignment','bottom');
Schrift(A+a+(b-h)/2,'\itp','HorizontalAlignment','center','VerticalAlignment','bottom');
axis('equal')
axis(ax)
axis('off')
print('-depsc','Heron');

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',60,varargin{:});

function r=Rot(a,b)
deg=pi/180;
r=atan2(b(2)-a(2),b(1)-a(1))/deg;
if r<0
  r=r+180;
end
if r>90
  r=r-180;
end
