function Kreissektor

% http://geometrie.hs-nb.de/MATLAB-Programme/Kreissektor.m   Bearbeitungsstand: 24.2.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf];
deg=pi/180;
wkl=35*deg;
alpha=10*deg;
beta=alpha+wkl;
O=[0;0];
A=[cos(alpha);sin(alpha)];
B=[cos(beta);sin(beta)];
drawPolygon(@plot,[A O B],'k')
hold('on')
K=Kreisbogen(A,O,B,0,'k','linewidth',4.0)
drawPolygon(@fill,[O K O],0.875*[1 1 1]);
Kreisbogen(B,O,A,0,'k');
Kreisbogen(0.35*A,O,0.35*B,0,'k','linewidth',0.5);
Kreisbogen(0.4*A,O,0.4*A,2*pi,'k','linewidth',0.5);
Schrift(O,'_{     }\alpha','rotation',(alpha+beta)/(2*deg),'HorizontalAlignment','left','VerticalAlignment','middle')
Schrift([cos((alpha+beta)/2);sin((alpha+beta)/2)],'\itb',...
  'rotation',(alpha+beta)/(2*deg)-90,'HorizontalAlignment','center','VerticalAlignment','bottom')
Schrift(2/3*[cos((alpha+beta)/2);sin((alpha+beta)/2)],'_{   }{\it A}_{Sektor}',...
  'rotation',0,'HorizontalAlignment','center','VerticalAlignment','middle')
Schrift([0;-0.275],'2\pi','HorizontalAlignment','center','VerticalAlignment','middle')
Schrift(A/2,'\itR','rotation',alpha/deg,'HorizontalAlignment','left','VerticalAlignment','top')
Schrift(B/2,'\itR','rotation',beta/deg,'HorizontalAlignment','left','VerticalAlignment','bottom')
hold('off')
hold('off')
axis('off')
axis('equal')
axis(ax)
print('-depsc','Kreissektor')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',36,varargin{:});

function P=Kreisbogen(A,M,B,offset,varargin)
deg=pi/180;
[t1,r1]=cart2pol(A(1)-M(1),A(2)-M(2));
[t2,r2]=cart2pol(B(1)-M(1),B(2)-M(2));
if abs(r1-r2)>sqrt(eps)
  error('Kreisbogen: A und B liegen nicht auf einem Kreis mit Mittelpunkt M')
end
r=(r1+r2)/2;
t1=t1-offset;
t2=t2+offset;
if t2<t1
  t2=t2+2*pi;
end
t=linspace(t1,t2,round((t2-t1)/deg));
P=repmat(M,size(t))+r*[cos(t);sin(t)];
drawPolygon(@plot,P,varargin{:});

