function Kreuzprodukt

% http://geometrie.hs-nb.de/MATLAB-Programme/Kreuzprodukt.m   Bearbeitungsstand: 3.3.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

% Ausserdem bentigt: geometrie.hs-nb.de/Bilder/rechteHand.JPG

global ax
deg=pi/180;
close('all')
A=imread('rechteHand.jpg');
image(A)
ax=[1 size(A,2) 1 size(A,1)];

O=[587;651];
hold('on');
O=[618.1579; 592.9649];
a=[502.0611;  92.1537];
b=[ 84.7718; 297.4120];
c=[ 68.1982; 496.2957];
c=O+1.0*(c-O);
drawPolygon(@fill,[O a a+b-O b O],0.875*[1 1 1]);
drawPolygon(@plot,[O a],'k','linewidth',2.0)
drawPolygon(@plot,[O b],'k','linewidth',2.0)
drawPolygon(@plot,[O c],'--k','linewidth',2.0)
h=10;
Spitze(a,a-O,50,45*pi/180);
Spitze(b,b-O,50,45*pi/180);
Spitze(c,c-O,50,45*pi/180);
Schrift((O+a)/2,'\bf\ita','HorizontalAlignment','center','VerticalAlignment','bottom',...
  'rotation',atan2(O(1)-a(1),O(2)-a(2))/deg-90)
Schrift((O+b)/2,'\bf\itb','HorizontalAlignment','left','VerticalAlignment','bottom',...
  'rotation',atan2(O(1)-b(1),O(2)-b(2))/deg-90)
Schrift((a+b)/2,{'{\itV}({\bf\ita},{\bf\itb})=' '  |{\bf\ita} \times {\bf\itb}|'},...
  'HorizontalAlignment','center','VerticalAlignment','middle')
aS=[a(2)-O(2);O(1)-a(1)];
aS=aS/norm(aS);
cr=1.5*norm(c)*aS;
drawPolygon(@plot,[O O+cr],'k','linewidth',2.0);
Spitze(O+cr,cr,50,45*pi/180);
Schrift(O+cr,'{\bf\ita}\times{\bf\itb}','HorizontalAlignment','left','VerticalAlignment','top',...
  'rotation',atan2(O(1)-a(1),O(2)-a(2))/deg)

hold('off');

axis('equal')
axis('off')
axis(ax)
print('-deps','Kreuzprodukt')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',21,varargin{:});

function Spitze(P,v,L,phi);
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*pi/180;
end
ta=tan(phi/2);
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
n=[-v(2,:);v(1,:)];
Q=P-v+ta*n;
R=P-v-ta*n;
for k=1:size(P,2);
  fill([P(1,k) Q(1,k) R(1,k)],[P(2,k) Q(2,k) R(2,k)],'k')
end
