function MUW

% http://geometrie.hs-nb.de/MATLAB-Programme/MUW.m   Bearbeitungsstand: 29.10.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf];
deg=pi/180;
t=[0:360]*deg;
t0=220*deg;
t1=t0+110*deg;
t2=80*deg;
t3=0.4*t0+0.6*t1;
P=[0 cos([t1 t2 t0]) 0
   0 sin([t1 t2 t0]) 0];
Q=[cos(t3)
   sin(t3)];
K=[cos(t);sin(t)];
drawPolygon(@fill,[Q P(:,[2 1 3 4 1]) Q],0.875*[1 1 1],'EdgeColor',0.875*[1 1 1])
v=P(:,4)-P(:,2);
Schrift(P(:,2),'\itB','Rotation',atan(v(2)/v(1))/deg,'FontSize',22);
Schrift(P(:,4),'\itA','Rotation',atan(v(2)/v(1))/deg,'FontSize',22,'HorizontalAlignment','right');
hold('on')

drawPolygon(@fill,[Q P(:,[4 1 3 2 1]) Q],0.75*[1 1 1],'EdgeColor',0.75*[1 1 1])
drawPolygon(@plot,K,'k')
drawPolygon(@plot,P,'k','linewidth',1.5)
drawPolygon(@plot,[P(:,4) Q P(:,[2 4])],'k','linewidth',1.5)
drawPolygon(@plot,[[0;0] P(:,3)],'k','linewidth',0.25)
drawPolygon(@plot,[[0;0] Q],'k','linewidth',0.25)
Schrift(mean(P(:,[1 2])')','\itr','Rotation',t1/deg,'HorizontalAlignment','center','VerticalAlignment','bottom')
Schrift(mean(P(:,[1 4])')','\itr','Rotation',180+t0/deg,'HorizontalAlignment','center','VerticalAlignment','bottom')
Schrift(mean([P(:,1) Q]')','\itr','Rotation',90+t3/deg,'HorizontalAlignment','left','VerticalAlignment','middle')
Schrift(P(:,1),'{\it\beta}_{1     }','Rotation',180+t0/deg,'HorizontalAlignment','right','VerticalAlignment','top')
Schrift(P(:,1),'{\it_{       }\beta}_2','Rotation',t1/deg,'HorizontalAlignment','left','VerticalAlignment','top')
Schrift(P(:,1),'{\it\gamma}_1','Rotation',180+t0/deg,'HorizontalAlignment','right','VerticalAlignment','bottom')
Schrift(P(:,1),'{\it\gamma}_2','Rotation',t1/deg,'HorizontalAlignment','left','VerticalAlignment','bottom')
q=0.2;
v=P(:,4)-Q;
v=v/norm(v);
Schrift(Q,'{\it\delta}_{1   }','Rotation',atan(v(2)/v(1))/deg,'HorizontalAlignment','right','VerticalAlignment','bottom')
drawCircle(@plot,P(:,4)-q*v,P(:,4),P(:,4)-q*[cos(t0);sin(t0)],0,'k','linewidth',0.25);
v=P(:,4)-P(:,2);
v=v/norm(v);
Schrift(P(:,4),'_{      }{\it\delta}_1','Rotation',atan(v(2)/v(1))/deg,'HorizontalAlignment','left','VerticalAlignment','middle')
Schrift(P(:,2),'{\it\delta}_{2     }','Rotation',atan(v(2)/v(1))/deg,'HorizontalAlignment','right','VerticalAlignment','middle')
q=0.17;
w=P(:,2)-Q;
w=w/norm(w);
v=P(:,4)-Q;
v=v/norm(v);
drawCircle(@plot,Q+q*w,Q,Q+q*v,0,'k','linewidth',0.25);
Schrift(Q,'_{   }{\it\delta}_2','Rotation',atan(w(2)/w(1))/deg,'HorizontalAlignment','left','VerticalAlignment','bottom')

drawCircle(@plot,P(:,2)-q*[cos(t1);sin(t1)],P(:,2),P(:,2)-q*w,0,'k','linewidth',0.25);


q=0.15;
drawCircle(@plot,q*[cos(t1);sin(t1)],[0;0],q*[cos(t0);sin(t0)],0,'k','linewidth',0.25);
q=0.25;
drawCircle(@plot,q*[cos(t0);sin(t0)],[0;0],q*[cos(t1);sin(t1)],0,'k','linewidth',0.25);
q=0.4;
drawCircle(@plot,q*[cos(t0);sin(t0)],[0;0],q*[cos(t1);sin(t1)],0,'k','linewidth',1.5);
v=P(:,4)-Q; v=v/norm(v);
w=P(:,2)-Q; w=w/norm(w);
Schrift(q*[cos(t3);sin(t3)],'\it\bf\beta','FontSize',22,'Rotation',t3/deg+90,'HorizontalAlignment','center','VerticalAlignment','bottom')
q=0.32;
drawCircle(@plot,Q+q*w,Q,Q+q*v,0,'k','linewidth',1.5);
Schrift(Q-q*[cos(t3);sin(t3)],'\it\bf\delta','FontSize',22,'Rotation',t3/deg+90,'HorizontalAlignment','center','VerticalAlignment','top')

q=0.36;
Schrift(P(:,3)-q*[cos(t2);sin(t2)],'{\it\alpha}_1','Rotation',t2/deg-90,'HorizontalAlignment','right','VerticalAlignment','bottom')
v=P(:,4)-P(:,3);
drawCircle(@plot,P(:,3)+q*v/norm(v),P(:,3),P(:,3)-q*[cos(t2);sin(t2)],0,'k','linewidth',0.25);
q=0.4;
Schrift(P(:,4)-q*[cos(t0);sin(t0)],'{\it\alpha}_1','Rotation',180+t0/deg,'HorizontalAlignment','right','VerticalAlignment','bottom')
drawCircle(@plot,P(:,4)-q*[cos(t0);sin(t0)],P(:,4),P(:,4)-q*v/norm(v),0,'k','linewidth',0.25);
q=0.25;
Schrift(P(:,3)-q*[cos(t2);sin(t2)],'{\it\alpha}_2','Rotation',t2/deg-90,'HorizontalAlignment','left','VerticalAlignment','bottom')
Schrift(P(:,2),'{\it\alpha}_{2       }','Rotation',t1/deg,'HorizontalAlignment','right','VerticalAlignment','bottom')
w=P(:,2)-P(:,3);
drawCircle(@plot,P(:,3)-q*[cos(t2);sin(t2)],P(:,3),P(:,3)+q*w/norm(w),0,'k','linewidth',0.25);
drawCircle(@plot,P(:,2)-q*w/norm(w),P(:,2),P(:,2)-q*[cos(t1);sin(t1)],0,'k','linewidth',0.25);
q=0.5;
drawCircle(@plot,P(:,3)+q*v/norm(v),P(:,3),P(:,3)+q*w/norm(w),0,'k','linewidth',1.5);
Schrift(P(:,3)+q*(P(:,1)-P(:,3)),'\bf\it\alpha','FontSize',22,'Rotation',t2/deg-90,'HorizontalAlignment','center','VerticalAlignment','bottom')
Schrift(P(:,3)+1.1*q*(P(:,1)-P(:,3)),'\itr','Rotation',t2/deg-90,'HorizontalAlignment','left','VerticalAlignment','top')

hold('off')
axis('off')
axis('equal')
axis(ax)
print('-deps','MUW')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function C=drawCircle(draw,A,M,B,offset,varargin)
deg=pi/180;
[t1,r1]=cart2pol(A(1)-M(1),A(2)-M(2));
[t2,r2]=cart2pol(B(1)-M(1),B(2)-M(2));
if abs(r1-r2)>sqrt(eps)
  error('Kreisbogen: A und B liegen nicht auf einem Kreis mit Mittelpunkt M')
end
r=(r1+r2)/2;
t1=t1-offset;
t2=t2+offset;
if t2<t1
  t2=t2+2*pi;
end
t=linspace(t1,t2,round((t2-t1)/deg));
C=repmat(M,size(t))+r*[cos(t);sin(t)];
drawPolygon(draw,C,varargin{:});

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',17,varargin{:});
