function O2P

% http://geometrie.hs-nb.de/MATLAB-Programme/O2P.m   Bearbeitungsstand: 4.3.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
deg=pi/180;
close('all')
global ax
P=[0;0;1.5];
ax=[-3 1 -2 2 0 P(3)+1];

Name='O2P-3d';
figure('numbertitle','off','name',Name);
drawPolygon(@fill3,[ax([1 2 2 1])
                    ax([3 3 4 4])
                    [0 0 0 0]],0.875*[1 1 1],'EdgeColor','none')
hold('on')
drawPolygon(@fill3,[ax([2 2 2 2])
                    ax([3 4 4 3])
                    ax([5 5 6 6])],0.75*[1 1 1],'EdgeColor','none')
drawPolygon(@plot3,[[P(1:2);0] P [ax(2);P(2:3)] [ax(2);P(2);0] [P(1:2);0]],'--k','erase','xor')
L=P(3)/7;
Schrift(ax([1;4;5]),'\Pi_1  ','HorizontalAlignment','left','VerticalAlignment','baseline','erase','xor')
Schrift(ax([2;4;6]),'\Pi_2','HorizontalAlignment','right','VerticalAlignment','top','erase','xor')
Schrift(P,'\itP','HorizontalAlignment','center','VerticalAlignment','baseline','erase','xor')
Schrift([P(1:2);0],'{\itP}''','HorizontalAlignment','center','VerticalAlignment','top','erase','xor')
Schrift([ax(2);P(2:3)],'\itP''''','HorizontalAlignment','center','VerticalAlignment','baseline','erase','xor')
hold('off')
view(-35,10);
axis('equal')
axis(ax)
axis('off')
print('-deps',Name)

Name='O2P-2d';
figure('numbertitle','off','name',Name);
drawPolygon(@plot3,[ax([1 2 2 1 1])
                    ax([3 3 4 4 3])
                    [0 0 0 0 0]],'k')
hold('on')
xmax=ax(2);
drawPolygon(@plot3,[xmax+ax([5 6 6 5 5])
                    ax([3 3 4 4 3])
                    [0 0 0 0 0]],'k')
Schrift(ax([1;4;5]),'_{ }\Pi_1','HorizontalAlignment','left','VerticalAlignment','bottom')
Schrift(ax([2;4;5]),'_{ }\Pi_2','HorizontalAlignment','left','VerticalAlignment','top')
Schrift([xmax ax([4;5])],{'^{ }Bild-' '_{ }achse'},'HorizontalAlignment','left','VerticalAlignment','middle')
Schrift([mean([P(1) xmax+P(3)]);P(2);0],'Ordner','Rotation',90,'HorizontalAlignment','center','VerticalAlignment','top')
drawPolygon(@plot3,[P [xmax+P(3);P(2);0]],'--ok','MarkerSize',10,'erase','xor')
Schrift([P(1:2);0],' {\itP} ''','HorizontalAlignment','left','VerticalAlignment','top')
Schrift([xmax+P(3);P(2);0],' {\itP} ''''','HorizontalAlignment','left','VerticalAlignment','bottom')
view([-90 90]);
M0=[ax(1)+0.1*(ax(2)-ax(1));ax(3)+0.15*(ax(4)-ax(3));0];
hold('off')
axis(ax)
axis('equal')
axis('off')
print('-deps',Name)

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),P(3,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end
if min(P(3,:))<ax(5)
  ax(5)=min(P(3,:));
end
if max(P(3,:))>ax(6)
  ax(6)=max(P(3,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),P(3),txt,'FontName','TimesNewRoman','FontSize',32,varargin{:});
