function Ortsvektor3d

% http://geometrie.hs-nb.de/MATLAB-Programme/Ortsvektor3d.m   Bearbeitungsstand: 7.6.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
deg=pi/180;
global ax
ax=[inf -inf inf -inf inf -inf];
a=[2;1.5;2.5];
O=[0;0;0];
drawPolygon(@plot3,[O a],'k','linewidth',1.5)
hold('on')
Spitze(a,a,0.5,30*deg);
Schrift(a,'\itA','FontSize',36,'HorizontalAlignment','left','VerticalAlignment','bottom');
Schrift(a/2,'_{ }\bf\ita','FontSize',36,'HorizontalAlignment','left','VerticalAlignment','middle');
Schrift([a(1);0;0],'_{  }{\ita}_1','HorizontalAlignment','center','VerticalAlignment','top');
Schrift([0;a(2);0],'{\ita}_{2   }','HorizontalAlignment','center','VerticalAlignment','middle');
Schrift([0;0;a(3)],'{\ita}_3','HorizontalAlignment','right','VerticalAlignment','middle');
h=0.25;
drawPolygon(@plot3,[[0;a(2);0] [a(1:2);0] [a(1);0;0]],'--k')
drawPolygon(@plot3,[[a(1:2);0] a [0;0;a(3)]],'--k')
drawPolygon(@plot3,[O [a(1:2);0]],'k')
Spitze([a(1:2);0],[a(1:2);0],h,45*pi/180)
Schrift([a(1:2);0]/2,'{\bf\ita}''','HorizontalAlignment','left','VerticalAlignment','middle');
drawPolygon(@plot3,[O [a(1)+3*h;0;0]],'k')
drawPolygon(@plot3,[O [0;a(2)+5*h;0]],'k')
drawPolygon(@plot3,[O [0;0;a(3)+9*h]],'k')
Spitze([ax(2);0;0],[1;0;0],h,45*pi/180)
Schrift([ax(2);0;0],'\itx','HorizontalAlignment','left','VerticalAlignment','middle');
Spitze([0;ax(4);0],[0;1;0],h,45*pi/180)
Schrift([0;ax(4);0],'\ity','HorizontalAlignment','center','VerticalAlignment','bottom');
Spitze([0;0;ax(6)],[0;0;1],h,45*pi/180)
Schrift([0;0;ax(6)],'\itz','HorizontalAlignment','center','VerticalAlignment','bottom');

hold('off')
axis('off')
view(-25,40)
axis('equal')
axis(ax+0.5*h*[-1 1 -1 1 -1 1])
print('-depsc','Ortsvektor3d')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),P(3,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end
if min(P(3,:))<ax(5)
  ax(5)=min(P(3,:));
end
if max(P(3,:))>ax(6)
  ax(6)=max(P(3,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),P(3),txt,'FontName','TimesNewRoman','FontSize',30,varargin{:});

function Spitze(P,v,L,phi);
deg=pi/180;
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*deg;
end
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
Q=P-v;
t=[0:6:360]*deg;
for k=1:size(P,2)
  N=tan(phi/2)*null(v(:,k)');
  for w=2:length(t)
    plot3(...
      [P(1,k) Q(1,k)+cos(t(w))*L(:,k)*N(1,1)+sin(t(w))*L(:,k)*N(1,2) Q(1,k)+cos(t(w-1))*L(:,k)*N(1,1)+sin(t(w-1))*L(:,k)*N(1,2) P(1,k)],...
      [P(2,k) Q(2,k)+cos(t(w))*L(:,k)*N(2,1)+sin(t(w))*L(:,k)*N(2,2) Q(2,k)+cos(t(w-1))*L(:,k)*N(2,1)+sin(t(w-1))*L(:,k)*N(2,2) P(2,k)],...
      [P(3,k) Q(3,k)+cos(t(w))*L(:,k)*N(3,1)+sin(t(w))*L(:,k)*N(3,2) Q(3,k)+cos(t(w-1))*L(:,k)*N(3,1)+sin(t(w-1))*L(:,k)*N(3,2) P(3,k)],...
      'k');
  end
end
