function Parallelspat

% http://geometrie.hs-nb.de/MATLAB-Programme/Parallelspat.m   Bearbeitungsstand: 19.8.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

% Ausserdem bentigt: geometrie.hs-nb.de/Bilder/rechteHand.JPG

global ax
deg=pi/180;
close('all')
B=imread('rechteHand.jpg');
A=uint8(zeros(size(B,2),size(B,1),3));
for k=1:3
  A(:,:,k)=B(end:-1:1,:,k)';
end
clear B
image(A)
ax=[1 size(A,2) 1 size(A,1)];

O=[587;651];
hold('on');
O=[388.4847;  598.7727];
a=[788.3190;  507.1440];
b=[609.6389;   67.7428];
c=[437.6392;   42.7532];
drawPolygon(@fill,[O a a+b-O b O],0.875*[1 1 1]);
drawPolygon(@plot,[O a],'k','linewidth',2.0)
drawPolygon(@plot,[O b],'k','linewidth',2.0)
drawPolygon(@plot,[O c],'k','linewidth',2.0)
drawPolygon(@plot,[a a+b-O b O],'k');
drawPolygon(@plot,[a a+c-O c O],'k');
drawPolygon(@plot,[b b+c-O c O],'k');
drawPolygon(@plot,[a-O+b a+b+c-2*O a-O+c a],'k');
drawPolygon(@plot,[b+c-O a+b+c-2*O],'k');
h=10;
Spitze(a,a-O,50,45*pi/180);
Spitze(b,b-O,50,45*pi/180);
Spitze(c,c-O,50,45*pi/180);
Schrift(a,'\bf\ita','HorizontalAlignment','left','VerticalAlignment','middle')
Schrift(b,' \bf\itb','HorizontalAlignment','center','VerticalAlignment','bottom')
Schrift(c,'\bf\itc','HorizontalAlignment','center','VerticalAlignment','bottom')
w=(atan2(a(2)-O(2),a(1)-O(1))+atan2(b(2)-O(2),b(1)-O(1)))/2;
Schrift((a+b)/2,'{\itG}=|{\bf\ita} \times {\bf\itb}|','HorizontalAlignment','center','VerticalAlignment','middle',...
  'rotation',w/deg+90)
aS=[a(2)-O(2);O(1)-a(1)];
aS=aS/norm(aS);
cr=2.3*norm(c)*aS;
drawPolygon(@plot,[O O+cr],'k');
Spitze(O+cr,cr,50,45*pi/180);
Schrift(O+cr,'{\bf\ita}\times{\bf\itb}','HorizontalAlignment','center','VerticalAlignment','bottom',...
  'rotation',atan2(O(1)-a(1),O(2)-a(2))/deg+90)
H=O+aS*aS'*(c-O);
offset=25*(H-c)/norm(H-c);
drawPolygon(@plot,[c H+2*offset],'k')
drawPolygon(@plot,[O+offset H+offset],'k')
drawPolygon(@plot,[O O+2*offset],'k')
Spitze(H+offset,cr,50,45*pi/180);
Schrift((H+O)/2+offset,'{\it Proj}_{{\bf\ita}\times{\bf\itb}}({\bf\itc})',...
  'HorizontalAlignment','center','VerticalAlignment','top','rotation',atan2(O(1)-a(1),O(2)-a(2))/deg)
hold('off');

axis('equal')
axis('off')
axis(ax)
print('-deps','Parallelspat')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',32,varargin{:});

function Spitze(P,v,L,phi);
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*pi/180;
end
ta=tan(phi/2);
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
n=[-v(2,:);v(1,:)];
Q=P-v+ta*n;
R=P-v-ta*n;
for k=1:size(P,2);
  fill([P(1,k) Q(1,k) R(1,k)],[P(2,k) Q(2,k) R(2,k)],'k')
end
