function RotStrecke

% http://geometrie.hs-nb.de/MATLAB-Programme/RotStrecke.m   Bearbeitungsstand: 29.9.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

global AbbNr
close all
AbbNr=0;
Abb([3;4;-2],[3;4;4]);
Abb([3;4;-2],[1.5;2;5]);
Abb([3;4;-2],[0;0;5]);
Abb([3;4;-2],[-1.5;-2;5]);
Abb([3;4;-2],[-2;3;4.5]);

function Abb(P0,P1)
global AbbNr
AbbNr=AbbNr+1;
deg=pi/180;
name=['RotStrecke-' int2str(AbbNr)];
figure('numbertitle','off','name',name);
plot3([0;0],[0;0],[-12;12],'-.k','linewidth',2.0)
hold('on')
v=P1-P0;
lambda=[0:360]*deg;
t=[0 1];
[Lambda,T]=meshgrid(lambda,t);
X=(P0(1)+T*v(1)).*cos(Lambda)-(P0(2)+T*v(2)).*sin(Lambda);
Y=(P0(1)+T*v(1)).*sin(Lambda)+(P0(2)+T*v(2)).*cos(Lambda);
Z=(P0(3)+T*v(3));
surf(X,Y,Z,Lambda)
c=0.5+0.375*(cos(pi*[0:size(Lambda,2)-1]/(size(Lambda,2)-1))).^2;
colormap(repmat(c',1,3));
shading('interp')
lambda=[0:15:360]*deg;
[Lambda,T]=meshgrid(lambda,t);
X=(P0(1)+T*v(1)).*cos(Lambda)-(P0(2)+T*v(2)).*sin(Lambda);
Y=(P0(1)+T*v(1)).*sin(Lambda)+(P0(2)+T*v(2)).*cos(Lambda);
Z=(P0(3)+T*v(3));
plot3(X,Y,Z,'k')
plot3(X(:,1),Y(:,1),Z(:,1),'k','linewidth',4.0)
Schrift(P0+[0;0;0.5],'{\itP}_0+{\ita\bfv}','HorizontalAlignment','right','VerticalAlignment','top','erase','none');
Schrift(P1+[0;0;0.1],'{\itP}_0+{\itb\bfv}','HorizontalAlignment','left','VerticalAlignment','baseline','erase','none');
view(150,12);
axis('equal')
axis([-4 4 -4 4 -3 5]);
axis('off')
print('-deps','-loose',name,'-opengl');

function Schrift(P,txt,varargin)
if length(P)==2
  P=[P;0];
end
text(P(1),P(2),P(3),txt,'FontName','TimesNewRoman','FontSize',54,varargin{:});
