function VolumenQuader

% http://geometrie.hs-nb.de/MATLAB-Programme/VolumenQuader.m   Bearbeitungsstand: 6.3.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf inf -inf];
a=[7;0;0];
b=[0;5;0];
c=[0;0;3];
A=[0;0;0];
[X,Y,Z]=meshgrid(0:a(1),0:b(2),0:c(3));
hold('on')
for r=1:size(X,1)
  x=squeeze(X(r,:,:));
  y=squeeze(Y(r,:,:));
  z=squeeze(Z(r,:,:));
  plot3(x,y,z,x',y',z','color',0.75*[1 1 1],'erase','none');
end
for r=1:size(X,2)
  x=squeeze(X(:,r,:));
  y=squeeze(Y(:,r,:));
  z=squeeze(Z(:,r,:));
  plot3(x,y,z,x',y',z','color',0.75*[1 1 1],'erase','none');
end
for r=1:size(X,3)
  x=squeeze(X(r,:,:));
  y=squeeze(Y(r,:,:));
  z=squeeze(Z(r,:,:));
  plot3(x,y,z,x',y',z','color',0.75*[1 1 1],'erase','none');
end
Polygon([A A+a A+a+b A+b A],'k','linewidth',1.5)
Polygon([A+c A+a+c A+a+b+c A+b+c A+c],'k','linewidth',1.5)
Polygon([A A+c],'k','linewidth',1.5)
Polygon([A+a A+a+c],'k','linewidth',1.5)
Polygon([A+b A+b+c],'k','linewidth',1.5)
Polygon([A+a+b A+a+b+c],'k','linewidth',1.5)
hold('off')
Schrift(A+a/2,'\ita','HorizontalAlignment','center','VerticalAlignment','top');
Schrift(A+b/2,'\itb','HorizontalAlignment','center','VerticalAlignment','top');
Schrift(A+b+c/2,'\itc_{ }','HorizontalAlignment','right','VerticalAlignment','middle');
axis('off')
view(-41,14)
axis('equal')
axis(ax+[-0.1 0.1 0 0 0 0])
print('-depsc','VolumenQuader');

function Polygon(P,varargin);
global ax
plot3(P(1,:),P(2,:),P(3,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end
if min(P(3,:))<ax(5)
  ax(5)=min(P(3,:));
end
if max(P(3,:))>ax(6)
  ax(6)=max(P(3,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),P(3),txt,'FontName','TimesNewRoman','FontSize',40,varargin{:});
