function WklVekVek

% http://geometrie.hs-nb.de/MATLAB-Programme/WklVekVek.m   Bearbeitungsstand: 18.10.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
ax=[inf -inf inf -inf];
deg=pi/180;
a=[3;4];
b=[-3;1];
c=b-a;
Polygon([[0;0] a b [0;0]],'k','linewidth',1.5)
hold('on')
h=0.5;
Spitze(a,a,h,30*deg);
Spitze(b,b,h,30*deg);
Spitze(b,c,h,30*deg);
Schrift(a/2,'\bf\ita','HorizontalAlignment','center','VerticalAlignment','bottom','rotation',atan2(a(2),a(1))/deg)
Schrift(b/2,'\bf\itb','HorizontalAlignment','center','VerticalAlignment','bottom','rotation',atan2(b(2),b(1))/deg+180)
Schrift(a+c/2,'{\bf\itb}-{\bf\ita}','HorizontalAlignment','center','VerticalAlignment','bottom',...
  'rotation',atan2(c(2),c(1))/deg+180)
Schrift([0;0],'\alpha^{  }','HorizontalAlignment','center','VerticalAlignment','bottom')
Kreisbogen(1.3*h*a/norm(a),[0;0],1.3*h*b/norm(b),0,'k')
hold('off')
axis('off')
axis('equal')
axis(ax)
print('-depsc','WklVekVek')

function Polygon(P,varargin);
global ax
plot(P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',50,varargin{:});

function Spitze(P,v,L,phi);
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*pi/180;
end
ta=tan(phi/2);
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
n=[-v(2,:);v(1,:)];
Q=P-v+ta*n;
R=P-v-ta*n;
for k=1:size(P,2);
  fill([P(1,k) Q(1,k) R(1,k)],[P(2,k) Q(2,k) R(2,k)],'k')
end


function Kreisbogen(A,M,B,offset,varargin)
deg=pi/180;
[t1,r1]=cart2pol(A(1)-M(1),A(2)-M(2));
[t2,r2]=cart2pol(B(1)-M(1),B(2)-M(2));
if abs(r1-r2)>sqrt(eps)
  error('Kreisbogen: A und B liegen nicht auf einem Kreis mit Mittelpunkt M')
end
r=(r1+r2)/2;
t1=t1-offset;
t2=t2+offset;
if t2<t1
  t2=t2+2*pi;
end
t=linspace(t1,t2,round((t2-t1)/deg));
Polygon(repmat(M,size(t))+r*[cos(t);sin(t)],varargin{:});
