function dAP

% http://geometrie.hs-nb.de/MATLAB-Programme/dAP.m   Bearbeitungsstand: 9.10.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

global ax QInl dQInl P
close('all')
ax=[inf -inf inf -inf];
QStr='[(4+sin(5*t)/3)*cos(t);(2+sin(7*t)/2)*sin(t)]';
dQStr=diff(QStr,'t');
QInl=inline(vectorize(QStr),'t');
dQInl=inline(['[' vectorize(dQStr(1,:)) ';' vectorize(dQStr(2,:)) ']'],'t');
t=linspace(0.2*pi,1.75*pi,100);
Q=QInl(t);
drawPolygon(@plot,Q,'k','linewidth',2.0);
Schrift(QInl(0.3*pi),'{\itP}({\itt})','HorizontalAlignment','left','VerticalAlignment','bottom')
hold('on')

A=[-7;-1];
AQ=Bsp(A,t);
Schrift(A,'\itA','HorizontalAlignment','left','VerticalAlignment','top')
Schrift(AQ-[0;0.35],'{\itP}({\itt_A})_{ }','HorizontalAlignment','right','VerticalAlignment','bottom')

B=[-1;0.25];
BQ=Bsp(B,t);
Schrift(B,' \itB','HorizontalAlignment','left','VerticalAlignment','bottom')
Schrift(BQ,'{\itP}({\itt_B})','HorizontalAlignment','center','VerticalAlignment','bottom')

C=[5;-3];
CQ=Bsp(C,t);
Schrift(C,'\itC','HorizontalAlignment','left','VerticalAlignment','bottom')
Schrift(CQ,'{\itP}({\itt_C})','HorizontalAlignment','center','VerticalAlignment','bottom')

hold('off')
axis('equal')
axis(ax)
axis('off')
print('-deps','dAP')

function Q=Bsp(A,t)
global QInl P
P=A;
drawPolygon(@plot,[QInl(t(end)) A QInl(t(1))],':k','linewidth',1.0)
Q=QInl(t(1));
if norm(QInl(t(end))-A)<norm(Q-A)
  Q=QInl(t(end));
end
drawPolygon(@plot,A,'.k','MarkerSize',30)
for k=2:length(t)
  if sk(t(k-1))*sk(t(k))<0
    tP=fzero(@sk,[t(k-1) t(k)]);
    drawPolygon(@plot,[A QInl(tP)],'--k')
    if norm(QInl(tP)-A)<norm(Q-A)
      Q=QInl(tP);
    end
  end
end
drawPolygon(@plot,Q,'ok','MarkerSize',10)

function s=sk(t)
global QInl dQInl P
s=dot(P-QInl(t),dQInl(t));

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',30,varargin{:});
