function dAG

% http://geometrie.hs-nb.de/MATLAB-Programme/dAg.m   Bearbeitungsstand: 19.1.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

close('all')
global ax
ax=[inf -inf inf -inf];
deg=pi/180;
A=[0;0];
v=[3;1];
v0=v/norm(v);
vL=4;
v=vL*v0;
drawPolygon(@plot,[A-0.1*v A+1.1*v],'k');
hold('on')
alpha=35*deg;
aL=3;
phi=atan2(v(2),v(1))+alpha;
a=aL*[cos(phi);sin(phi)];
proj=v0*v0'*a;
orth=a-proj;
drawPolygon(@plot,[A+proj A A+a],'k','linewidth',2.0);
drawPolygon(@plot,[A+proj A+a],'k');
drawPolygon(@plot,[A+proj+0.1*v A+v],'k','linewidth',2.0);
h=0.4;
Spitze(A+v,v,h,25*deg);
Spitze(A+a,a,h,25*deg);
Spitze(A+proj,proj,h,25*deg);
Schrift(A+(proj+1.1*v)/2,'\it\bfv','rotation',atan(v(2)/v(1))/deg,'HorizontalAlignment','center','VerticalAlignment','top');
Schrift(A+proj/2,'{\itProj_{\bfv}}({\itA}-{\itP}_0) ','rotation',atan(v(2)/v(1))/deg,'HorizontalAlignment','center','VerticalAlignment','top');
Schrift(A+a/2,'{\itA}-{\itP}_0','rotation',atan(a(2)/a(1))/deg,'HorizontalAlignment','center','VerticalAlignment','bottom');
Schrift(A+proj+orth/2,'  {\itd}({\itA},{\itg})','rotation',atan(orth(2)/orth(1))/deg,...
  'HorizontalAlignment','center','VerticalAlignment','bottom');
Schrift(A-0.1*v,'\itg','HorizontalAlignment','right','VerticalAlignment','middle');
Schrift(A,'{\itP}_0','HorizontalAlignment','center','VerticalAlignment','top');
Schrift(A+proj,'{\itA}_{\itg}','HorizontalAlignment','left','VerticalAlignment','top');
Schrift(A+a,' \itA','HorizontalAlignment','left','VerticalAlignment','bottom');
drawPolygon(@plot,A+a,'.k','MarkerSize',30)
drawPolygon(@plot,A+proj,'ok','MarkerSize',10)

hold('off')
axis('off')
axis('equal')
axis(ax)
print('-deps','dAg')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',37,varargin{:});

function Spitze(P,v,L,phi);
if nargin<=2
  L=1;
end
if nargin<=3
  phi=7.5*pi/180;
end
ta=tan(phi/2);
v=L*v./repmat(sqrt(dot(v,v)),size(P,1),1);
n=[-v(2,:);v(1,:)];
Q=P-v+ta*n;
R=P-v-ta*n;
for k=1:size(P,2);
  fill([P(1,k) Q(1,k) R(1,k)],[P(2,k) Q(2,k) R(2,k)],'k')
end
