function dPQ

% http://geometrie.hs-nb.de/MATLAB-Programme/dPQ.m   Bearbeitungsstand: 7.3.2005
% (C) Martin Nitschke, nitschke@hs-nb.de

global ax 
close('all')
ax=[inf -inf inf -inf];
PStr='[(4+sin(5*t)/3)*cos(t);(1.6+sin(7*t-0.1)/2)*sin(t)/(1+(t/12)^2)]';
QStr='[1.5*(3+sin(5*s)/3)*cos(s)+(2+sin(7*s)/2)*sin(s)-10;(4+sin(5*s)/3)*cos(s)-(1+sin(7*s)/2)*sin(s)]';
dPStr=diff(PStr,'t');
dQStr=diff(QStr,'s');
PInl=inline(vectorize(PStr),'t');
QInl=inline(vectorize(QStr),'s');
% dPInl=inline(['[' vectorize(dPStr(1,:)) ';' vectorize(dPStr(2,:)) ']'],'t');
% dQInl=inline(['[' vectorize(dQStr(1,:)) ';' vectorize(dQStr(2,:)) ']'],'s');
t=linspace(0.5*pi,1.2*pi,100);
s=linspace(0.2*pi,0.5*pi,100);
P=PInl(t);
Q=QInl(s);
drawPolygon(@plot,P,'k','linewidth',2.0);
hold('on')
drawPolygon(@plot,Q,'k','linewidth',2.0);
d=inline('norm(PInl(u(1))-QInl(u(2)))','u','PInl','QInl');
u=fminsearch(d,[mean(t) mean(s)],[],PInl,QInl);
drawPolygon(@plot,[PInl(u(1)) QInl(u(2))],'--.k','MarkerSize',30)
Schrift(PInl(t(1)),'{\itQ}({\its})','HorizontalAlignment','right','VerticalAlignment','top')
Schrift(PInl(u(1)),'^{ }{\itQ}({\its*})','HorizontalAlignment','left','VerticalAlignment','middle')
Schrift(QInl(s(1)),'{\itP}({\itt})   ','HorizontalAlignment','right','VerticalAlignment','top')
Schrift(QInl(u(2)),'{\itP}({\itt*}) ','HorizontalAlignment','right','VerticalAlignment','middle')
hold('off')
axis('equal')
axis(ax)
axis('off')
print('-deps','dPQ')

function drawPolygon(draw,P,varargin);
global ax
feval(draw,P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end

function Schrift(P,txt,varargin)
text(P(1),P(2),txt,'FontName','TimesNewRoman','FontSize',30,varargin{:});
