function eps2pdf(ptn)

% http://geometrie.hs-nb.de/MATLAB-Programme/eps2pdf.m   Bearbeitungsstand: 1.3.2008
% (C) Martin Nitschke, nitschke@hs-nb.de

if nargin
  D=dir(ptn);
else
  D=dir('*.eps');
end
for k=1:length(D)
  [pth,name,ext]=fileparts(D(k).name);
  epsid=fopen([name '.eps'],'r');
  BB=zeros(4,1);
  while 1
    line=fgetl(epsid);
    if ~ischar(line), break, end
    p=strfind(line,'%%BoundingBox:');
    if ~isempty(p)
      BB=sscanf(line(length('%%BoundingBox:')+1:end),'%d');
      hei=BB(3)-BB(1);
      wid=BB(4)-BB(2);
      break
    end
  end
  fclose(epsid)
  TeXid=fopen([name '.TeX'],'w');
  fprintf(TeXid,'\\documentclass[10pt]{article}\n');
  fprintf(TeXid,'\\usepackage[dvips,papersize={%dpt,%dpt}]{geometry}\n',hei,wid);
  fprintf(TeXid,'\\usepackage{epsfig}\n');
  fprintf(TeXid,'\\hoffset-1in\n');
  fprintf(TeXid,'\\voffset-75pt\n');
  fprintf(TeXid,'\\evensidemargin0pt\n');
  fprintf(TeXid,'\\oddsidemargin0pt\n');
  fprintf(TeXid,'\\topmargin0pt\n');
  fprintf(TeXid,'\\headheight0pt\n');
  fprintf(TeXid,'\\headsep0pt\n');
  fprintf(TeXid,'\\textheight%dpt\n',hei);
  fprintf(TeXid,'\\textwidth%dpt\n',wid);
  fprintf(TeXid,'\\marginparsep0pt\n');
  fprintf(TeXid,'\\marginparwidth0pt\n');
  fprintf(TeXid,'\\footskip0pt\n');
  fprintf(TeXid,'\\parindent0pt\n');
  fprintf(TeXid,'\\pagestyle{empty}\n');
  fprintf(TeXid,'\\begin{document}\\epsfig{file=%s}\\end{document}\n',name);
  fclose(TeXid);
  OS(['LaTeX ' name]);
  delete([name '.TeX'])
  delete([name '.aux'])
  logid=fopen([name '.log'],'r');
  while 1
    line=fgetl(logid);
    if ~ischar(line), break, end
    p=strfind(line,['Output written on ' name '.dvi']);
    if ~isempty(p)
      pb=sscanf(line,['Output written on ' name '.dvi (%d page%s)']);
      pge=pb(1);
      break
    end
  end
  fclose(logid);
  delete([name '.log'])
  OS(['dvips -p' int2str(pge) ' -o' name '.ps -Ppdf ' name '.dvi']);
  delete([name '.dvi'])
  % delete([name '.eps'])
  % OS(['D:\programme\gs\gs8.54\lib\ps2pdf.bat -dAutoRotatePages#/None -dAutoPositionEPSFiles#false ' ...
  %   name '.ps ' name '.pdf']);
  OS(['D:\programme\gs\gs8.54\bin\gswin32c -dBATCH -dNOPAUSE -sDEVICE=pdfwrite -dAutoRotatePages=/None -dAutoPositionEPSFiles=false -sOutputFile=' name '.pdf ' name '.ps']);
  delete([name '.ps'])
  winopen([name '.pdf'])
end

function OS(cmd)
disp(['*DOS* ' cmd]);
dos(cmd);
