function nEcke

% http://geometrie.hs-nb.de/MATLAB-Programme/nEcke.m   Bearbeitungsstand: 26.4.2004
% (C) Martin Nitschke, nitschke@hs-nb.de

clc;
close('all')
global ax
deg=pi/180;
verschieb=inline('P+repmat(v,1,size(P,2))','P','v');
nEck=inline('repmat(r,2,1).*[cos(t);sin(t)]','r','t');
ax=[inf -inf inf -inf];
t=linspace(0,2*pi,12);
Q=nEck(3+cos(5.2*t),t);
P=Q(:,[1:3 5 4 6:end]);
I1=1:round(size(P,2)/2);
Polygon(P(:,I1),'k','linewidth',1.5)
hold('on')

vOffset=-(max(P(2,I1))-min(P(2,I1))); P=verschieb(P,[0;vOffset]);
Polygon(P(:,[1:end 1]),'k','linewidth',1.5)

P=P(:,[1:2:end 2:2:end]);
vOffset=-(max(P(2,:))-min(P(2,:))); P=verschieb(P,[0;vOffset]);
Polygon(P(:,[1:end 1]),'k','linewidth',1.5)

vOffset=-2.5*(max(P(2,:))-min(P(2,:))); P=verschieb(Q,[0;vOffset]);
Polygon(P(:,[1:end 1]),'k','linewidth',1.5)
for n=1:size(P,2)
  Polygon([[mean(P(1,:));P(2,2)] P(:,n)],'k','linewidth',0.25);
end

P=P(:,convhull(P(1,:),P(2,:)));
vOffset=-(max(P(2,:))-min(P(2,:))); P=verschieb(P,[0;vOffset]);
Polygon(P(:,[1:end 1]),'k','linewidth',1.5)
for n=1:size(P,2)
  for m=n+1:size(P,2)
    Polygon([P(:,m) P(:,n)],'k','linewidth',0.25);
  end
end

r=3;
vOffset=1.01*(min(P(2,:))-r); 
P=nEck(repmat(r,size(t)),t); 
P=verschieb(P,[0;vOffset]);
Polygon(P(:,[1:end 1]),'k','linewidth',1.5)

hold('off')
axis('equal')
axis(ax)
axis('off')
print('-deps','nEcke')

function Polygon(P,varargin);
global ax
plot(P(1,:),P(2,:),varargin{:})
if min(P(1,:))<ax(1)
  ax(1)=min(P(1,:));
end
if max(P(1,:))>ax(2)
  ax(2)=max(P(1,:));
end
if min(P(2,:))<ax(3)
  ax(3)=min(P(2,:));
end
if max(P(2,:))>ax(4)
  ax(4)=max(P(2,:));
end
